/*
	$Id: address.c,v 1.15 2012/04/03 03:51:40 alex Exp alex $
	address.c--- address book
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: address.c,v 1.15 2012/04/03 03:51:40 alex Exp alex $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<string.h>
#include	<signal.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

#define	STATUS_NORMAL	EDB_PRINT_STATUS_NORMAL
#define	STATUS_WARNING	EDB_PRINT_STATUS_WARNING
#define	STATUS_ALERT	EDB_PRINT_STATUS_ALERT

static	int	misc_address __P((Book, Section));
static	int	address_dept __P((Book, Section));

struct SECTION	misc_address_part[] = {
{	"ce",		"建設工学科",			11077,	NUM_arabic,	address_dept,	NULL	},
{	"me",	"機械工学科",			11090,	NUM_arabic,	address_dept,	NULL	},
{	"chem",	"化学応用工学科",		11103,	NUM_arabic,	address_dept,	NULL	},
{	"ee",		"電気電子工学科",		11115,	NUM_arabic,	address_dept,	NULL	},
{	"is",		"知能情報工学科",		11128,	NUM_arabic,	address_dept,	NULL	},
{	"bio",		"生物工学科",			11139,	NUM_arabic,	address_dept,	NULL	},
{	"opt",	"光応用工学科",		11150,	NUM_arabic,	address_dept,	NULL	},
{	"pm",	"共通講座",			11159,	NUM_arabic,	address_dept,	NULL	},
{	"eco",	"エコシステム工学専攻",	11044,	NUM_arabic,	address_dept,	NULL	},
{	"mmc",	"機械工作センター",		11021,	NUM_arabic,	address_dept,	NULL	},
{	"admin",	"事務部",				11051,	NUM_arabic,	address_dept,	NULL	},
{	NULL,	NULL,				0,		NUM_none,	NULL,		NULL	}
};
struct SECTION	misc_part[] = {
{	"address",		"工学部教職員住所録（取扱注意）",	ORGAN_UNIV_EID,	NUM_arabic,	misc_address,	misc_address_part	},
{	NULL,		NULL,							0,		NUM_none,	NULL,		NULL	}
};

struct BOOK	book_misc = {
	WEB_DOCUMENT_ROOT "/book/misc",
	"index",
	"MISC",
	"",
	ORGAN_UNIV_EID,
	NUM_none,
	{20010401, 20020331},
	{20010401, 20020331},
	misc_part
};

#if 0
static eid_t	official_title[] = TITLE_PERSONNEL_LIST	;
#endif

static
Link
edb_book_misc_organization_collect_official(EdbPrint ep, Book book, eid_t organ_eid)
{
	Link	l, l_eid, l_result;
	EdbTableInfo	table_ti;

	table_ti = edb_table_get_by_name(ep->ec, (utf8_t *)EDB_TABLE_PERSON_XN);
	edb_table_prefetch_tuples(ep->ec, table_ti);
	l_eid = edb_book_get_eid_list(ep->ec, TABLE_EID(table_ti), NULL);
	l_result = NULL;
	ForLink(l, l_eid) {
		EdbTupleInfo	tuple;
		EdbTupleColumn	tc;
		EdbDatum	datum;
		int	k;

		tuple = edb_tuple_get(ep->ec, ATOI((char *)l->d), TEMPLATE(table_ti), 0);
		if(tuple==NULL) continue;
#if 0
		if(TupleMapto(tuple)) continue;
#endif
		tc = TupleColumn_person_title(ep->ec, tuple);
		if(tc==NULL) continue;
		datum = TCDatumFirst(tc);
		if(!DatumEIDisValid(datum)) continue;
#if 0
		for(k=0; k<Ns(official_title); ++k) {
			if(EIDisVALID(official_title[k]) && DatumEID(datum)==official_title[k]) break;
		}
		if(k==Ns(official_title)) continue;
#else
		for(k=0; edb_title_personnel_list[k]; ++k) {
			if(EIDisVALID(edb_title_personnel_list[k]) && DatumEID(datum)==edb_title_personnel_list[k]) break;
		}
		if(!EIDisVALID(edb_title_personnel_list[k])) continue;
#endif
		if(organ_eid==0 || edb_book_tuple_column_match_eid(ep->ec, tuple, "所属", organ_eid)) {
			LinkAppend(l_result, link_atom_new_sdup((char *)l->d));
		}
	}
	return l_result;
}

static
int
edb_book_print_address(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;

	edb_print_push(ep);
	EpLang(ep) = EP_LANG_Japanese;
	HTML(doc) doc_puts(doc, "<tr>\n");
	if(tuple==NULL) {
		HTML(doc) {
			doc_printf(doc, "<th>%s</th>\n", "講座名");
			doc_printf(doc, "<th>%s</th>\n", "職名");
			doc_printf(doc, "<th>%s</th>\n", "氏名");
			doc_printf(doc, "<th>%s</th>\n", "電子メール");
			doc_printf(doc, "<th>%s</th>\n", "部屋");
			doc_printf(doc, "<th>%s</th>\n", "郵便番号");
			doc_printf(doc, "<th>%s</th>\n", "自宅住所");
			doc_printf(doc, "<th>%s</th>\n", "自宅電話番号");
			doc_printf(doc, "<th>%s</th>\n", "職場電話番号");
			doc_printf(doc, "<th>%s</th>\n", "職場内線番号");
		}
		PLAIN(doc) {
			doc_printf(doc, "%s\t", "講座名");
			doc_printf(doc, "%s\t", "職名");
			doc_printf(doc, "%s\t", "氏名");
			doc_printf(doc, "%s\t", "電子メール");
			doc_printf(doc, "%s\t", "部屋");
			doc_printf(doc, "%s\t", "郵便番号");
			doc_printf(doc, "%s\t", "自宅住所");
			doc_printf(doc, "%s\t", "自宅電話番号");
			doc_printf(doc, "%s\t", "職場電話番号");
			doc_printf(doc, "%s\n", "職場内線番号");
		}
	} else {
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "所属", 0, EP_TCD_MODE_NORECURSION, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "肩書", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
#if 1
		edb_print_tuple_prefix(ep, tuple);
#endif
		edb_book_print_person_info_name(ep, tuple, TRUE, TRUE);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "電子メール", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "部屋", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "郵便番号", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "住所", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "電話3", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "電話", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\t");
		HTML(doc) doc_puts(doc, "<td>");
		edb_book_print_text(ep, tuple, "電話2", 0, 0, EP_ALERT);
		HTML(doc) doc_puts(doc, "</td>\n");
		PLAIN(doc) doc_puts(doc, "\n");
	}
	HTML(doc) doc_puts(doc, "</tr>\n");
	edb_print_pop(ep);
	return TRUE;
}

static
int
address_dept(Book book, Section sec)
{
	register EdbPrint	ep = sec->ep;
	Link	l;

	PLAIN(sec->ep->doc) doc_printf(sec->ep->doc, "%s\n", sec->title);
	HTML(sec->ep->doc) doc_printf(sec->ep->doc, "<h2>%s</h2>\n", sec->title);

	HTML(sec->ep->doc) doc_printf(sec->ep->doc, "（<a href=\"%s.txt\">テキスト形式</a>; TAB文字が区切りになっています．）\n", sec->name);

	HTML(sec->ep->doc) doc_puts(sec->ep->doc, "<TABLE border=\"2\">\n");
	edb_book_print_address(sec->ep, NULL);
	for(l=sec->l_person; l; l=l->n) {
		EdbTupleInfo	rtuple;

		rtuple = edb_tuple_get(ep->ec, ATOI((char *)l->d), 0);
		edb_book_print_address(sec->ep, rtuple);
	}
	HTML(sec->ep->doc) doc_puts(sec->ep->doc, "</TABLE>\n");
	return TRUE;
}

static
int
misc_address(Book book, Section sec)
{
	register EdbPrint	ep = sec->ep;
	int	i, t;
	char	str[BUFSIZ];
	Link	l, l_remain_person;
	Section	subsec;

	if(sec->sec==NULL) return FALSE;
	PLAIN(sec->ep->doc) if(book->ep != sec->ep) doc_printf(sec->ep->doc, "%s %s\n", sec->secno, sec->title);
	HTML(sec->ep->doc) {
		if(book->ep != sec->ep) doc_printf(sec->ep->doc, "<h2>%s %s</h2>\n", sec->secno, sec->title);
		doc_printf(sec->ep->doc, "このページは" NAME_OF_DB "ユーザにのみ提供しています．\n");
	}

	for(i=0; (subsec=&sec->sec[i])->title; ++i) {
		if(subsec->organ_eid) {
			subsec->organ_eids = edb_book_get_organ_lower_eids(ep->ec, subsec->organ_eid);
		} else {
			subsec->organ_eids = NULL;
		}
		subsec->l_eid = NULL;
	}

	sec->l_person = edb_book_misc_organization_collect_official(ep, book, 0);
	l_remain_person = edb_book_classify_into_organization(ep->ec, book, sec->l_person, "所属", sec->sec);
	for(i=0; (subsec=&sec->sec[i])->title; ++i) {
		subsec->l_person = subsec->l_eid;
		subsec->l_eid = NULL;
	}

	HTML(sec->ep->doc) doc_puts(sec->ep->doc, "<ul>\n");
	for(i=0; (subsec=&sec->sec[i])->title; ++i) {
		char	name[BUFSIZ];
		char	name_tmp[BUFSIZ];
		char	secno[BUFSIZ];
		char	title[BUFSIZ];

		if(sec->layer==0) {
			sprintf(subsec->secno, "%s.", edb_book_int2numstr(secno, i+1, sec->number));
		} else {
			sprintf(subsec->secno, "%s%s", sec->secno, edb_book_int2numstr(secno, i+1, sec->number));
		}
		if(subsec->name) {
			HTML(sec->ep->doc) doc_printf(sec->ep->doc, "<li><a href=\"%s.html\">%s</a>\n", subsec->name, subsec->title);
			PLAIN(sec->ep->doc) sprintf(name, "%s.txt", subsec->name);
			HTML(sec->ep->doc) sprintf(name, "%s.html", subsec->name);
			TeX(sec->ep->doc) sprintf(name, "%s.tex", subsec->name);
			subsec->ep = edb_print_dup(sec->ep);
			sprintf(name_tmp, "%s.tmp", subsec->name);
			subsec->ep->doc = doc_open(sec->ep->doc->dml, name_tmp, "w+");
			if(subsec->ep->doc==NULL) {
				fprintf(book->err_fp, "cannot create file.\n");
				return FALSE;
			}
			sprintf(title, "%s %s", subsec->secno, subsec->title);
			HTML(subsec->ep->doc) edb_book_begin_HTML(subsec->ep, book, title);
		} else {
			HTML(sec->ep->doc) doc_printf(sec->ep->doc, "<li>%s\n", subsec->title);
			subsec->ep->doc = sec->ep->doc;
		}
		subsec->layer = sec->layer+1;
		PLAIN(sec->ep->doc) {
			if(subsec->func) (*subsec->func)(book, subsec);
		}
		HTML(sec->ep->doc) {
			if(subsec->func) (*subsec->func)(book, subsec);
		}
		if(subsec->name) {
			HTML(subsec->ep->doc) edb_book_end_HTML(subsec->ep, book);
			doc_close(subsec->ep->doc);
			file_update(name_tmp, name);
		}
	}
	HTML(sec->ep->doc) doc_puts(sec->ep->doc, "</ul>\n");
#if 0
	HTML(sec->ep->doc) {
		if(l_remain_person) {
			doc_puts(sec->ep->doc, "<hr />\n");
			if(!ep->nocolor) doc_color_begin(sec->ep->doc, WARNING_COLOR);
			doc_puts(sec->ep->doc, "<h4>分類できなかった情報</h4>\n");
			doc_puts(sec->ep->doc, "<ul>\n");
			for(l=l_remain_person; l; l=l->n) {
				EdbTableInfo	ti;

				ti = edb_tuple_get(ep->ec, ATOI((char *)l->d), 0);
				doc_puts(sec->ep->doc, "<li>\n");
				edb_book_print_person_profile(sec->ep, ti);
			}
			doc_puts(sec->ep->doc, "</ul>\n");
			if(!ep->nocolor) doc_color_end(sec->ep->doc);
		}
	}
#endif
	for(i=0; (subsec=&sec->sec[i])->title; ++i) {
		link_free(subsec->l_person);
		subsec->l_person = NULL;
	}
	link_free(l_remain_person);
	link_free(sec->l_person);
	sec->l_person = NULL;
	return TRUE;
}


