/*
	$Id: javascript.c,v 1.3 2011/04/18 09:45:59 alex Exp $
	js.c--- JavaScript
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: javascript.c,v 1.3 2011/04/18 09:45:59 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	"edb/edb.h"
#include	"edb/doc.h"
#include	"edb/javascript.h"

void
JavaScript_begin(Doc doc)
{

	doc_puts(doc, "<script language=\"JavaScript\" type=\"text/javascript\"><!--\n");
}

void
JavaScript_end(Doc doc)
{

	doc_puts(doc, "// --></script>\n");
}

void
JavaScript_puts(Doc doc, char *content)
{

	JavaScript_begin(doc);
	doc_puts(doc, content);
	JavaScript_end(doc);
}

void
JavaScript_printf(Doc doc, char *fmt, ...)
{
	va_list	ap;
	char	*content;

	JavaScript_begin(doc);
	if(fmt) {
		va_start(ap, fmt);
		vasprintf(&content, fmt, ap);
		va_end(ap);
		doc_puts(doc, content);
		FREE(content);
	}
	JavaScript_end(doc);
}

void
JavaScript_source(Doc doc, char *src)
{

	doc_printf(doc, "<script language=\"JavaScript\" type=\"text/javascript\" src=\"%s\"></script>\n", src);
}

void
JavaScript_requirement(Doc doc)
{

	doc_puts(doc, "<noscript style=\"font-size:150%; color:red;\">ブラウザのJavaScriptを有効にして下さい．<br />Please activate JavaScript function on your browser.<br /></noscript>\n");
}

void
JavaScript_put_file(Doc doc, char *name)
{
	Link	l, lstr;

	lstr = file_load_as_linked_str(name, stderr);
	if(lstr) {
		JavaScript_begin(doc);
		ForLink(l, lstr) {
			doc_puts(doc, l->d);
			doc_puts(doc, "\n");
		}
		JavaScript_end(doc);
		link_free(lstr);
	}
}


