/*
	$Id: mod_collaboration.c,v 1.5 2004/12/04 06:04:18 alex Exp $
	mod_collaboration.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_collaboration.c,v 1.5 2004/12/04 06:04:18 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

static
int
print_researcher(EdbPrint ep, EdbTupleInfo tuple, EdbDatum super_datum)
{
	register int	status;

	if(super_datum==NULL) return FALSE;
	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, super_datum, " (", "", "@.researcher", NULL, ", ", ")", NULL, EP_ALERT);
	edb_print_pop(ep);
	return status;
}

static
int
edb_book_print_collaboration(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;
	EdbTupleColumn	tco, tcp;
	int	japanese = TRUE;
	eid_t	eid;
	EdbDatum	od = NULL;
	int	i;
	int	status = EP_STATUS_NORMAL;

	edb_print_push(ep);
	if(EpLang(ep)==EP_LANG_Auto) EpLang(ep) = EP_LANG_Japanese;
	ep->ct->tcd_idx_prefix = NULL;

	edb_print_tuple_prefix(ep, tuple);

#if 0
	tco = edb_tuple_seek_column(ep->ec, tuple, "@.organization");
	if(tco==NULL || tco->datum==NULL) {
		edb_print_alert(ep, EP_ALERT, "@.organization");
	} else {
		EdbDatum	d;

		edb_print_push(ep);
		ep->ct->tcd_idx = 1;
		ForTCDatum(d, tco) {
			edb_print_tcd(ep, tuple, tco, d);
			tcp = edb_tuple_seek_TC_by_xmlname(ep->ec, tuple, tco, d, "@.researcher");
			if(tcp==NULL || tcp->datum==NULL) {
				edb_print_alert(ep, EP_WARNING, "@.researcher");
			} else {
				int	idx = 0;
				EdbDatum	dp;

				NotLaTeX(ep) doc_prefix_set(doc, " (");
				ForTCDatum(dp, tcp) {
					edb_print_push(ep);
					EpLang(ep) = japanese ? EP_LANG_Japanese : EP_LANG_English;
					ep->ct->tcd_mode = EP_TCD_MODE_BOLD;
					ep->ct->tcd_idx_prefix = NULL;
					ep->ct->tcd_idx = idx+1;
					edb_print_tcd(ep, tuple, tcp, dp);
					edb_print_pop(ep);
					status |= EpStatus(ep);
					NotLaTeX(ep) if(dp->n) doc_puts(doc, ", ");
					++idx;
				}
				NotLaTeX(ep) doc_puts(doc, ")");
			}
			edb_book_print_delimiter(ep, TRUE, ", ");
			++ep->ct->tcd_idx;
		}
		edb_print_pop(ep);
	}
#else
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.organization", print_researcher, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");
#endif

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.theme", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.period", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, TRUE, ".");

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}

static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	EDB_TABLE_Collaboration_XN,
/* language */	NULL,
/* std */	edb_book_print_collaboration,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_collaboration
};
#ifdef	THE_UNIVERSITY_OF_TOKUSHIMA
DECLARE_PRINT_MODULE(collaboration, module_info)
#endif

