/*
	$Id: mod_prize.c,v 1.6 2012/04/03 03:51:40 alex Exp alex $
	mod_prize.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_prize.c,v 1.6 2012/04/03 03:51:40 alex Exp alex $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

#define	STUDENT_FGC	"#008000"

static
int
awardee_is_student(EdbContext ec, EdbTupleInfo tuple, EdbTupleColumn tc, EdbDatum datum)
{
	EdbTupleColumn ttc;

	// 学籍番号
	ttc = edb_tuple_seek_TC_by_xmlname(ec, tuple, tc, datum, (utf8_t *)"@.studentcode");
	if(ttc!=NULL && ttc->datum!=NULL && DatumEnglishIsValid(ttc->datum)) return TRUE;

	// 学生(所属)
////	ttc = edb_tuple_seek_TC_by_xmlname(ec, tuple, tc, datum, (utf8_t *)"@.affiliate");
////	if(ttc==NULL || ttc->datum==NULL || !DatumEIDisValid(ttc->datum)) return FALSE;
////
////	// 学生(肩書)
////	ttc = edb_tuple_seek_TC_by_xmlname(ec, tuple, tc, datum, (utf8_t *)"@.title");
////	if(ttc==NULL || ttc->datum==NULL || !DatumEIDisValid(ttc->datum)) return FALSE;
////	return TRUE;
	return FALSE;
}

static
int
prize_print_awardee(EdbPrint ep, EdbTupleInfo tuple, EdbTupleColumn tc, EdbDatum datum)
{
	int	st = 0;

	edb_print_push(ep);
	edb_print_tcd_register_func(ep, "prize.awardee", PrintStyle(ep), NULL);
	if(!ep->ct->nocolor && !strcmp((char *)ColumnXN(tc->ci), "prize.awardee") && awardee_is_student(ep->ec, tuple, tc, datum)) {
		doc_color_begin(ep->doc, STUDENT_FGC);
		st = edb_print_tcd(ep, tuple, tc, datum);
		doc_color_end(ep->doc);
	} else {
		st = edb_print_tcd(ep, tuple, tc, datum);
	}
	edb_print_pop(ep);
	return st;
}

static
int
edb_book_print_prize(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;
	int	japanese = TRUE;
	int	status = EP_STATUS_NORMAL;

	edb_print_push(ep);
	if(EpLang(ep)==EP_LANG_Auto) EpLang(ep) = EP_LANG_Japanese;
	edb_print_tuple_prefix(ep, tuple);

	edb_print_push(ep);
	HTML(ep->doc) edb_print_tcd_register_func(ep, "prize.awardee", PrintStyle(ep), prize_print_awardee);
	ep->ct->column_mode |= EP_COLUMN_MODE_LIST_AND;
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.awardee", NULL, ", ", "", NULL, EP_ALERT);
	edb_print_pop(ep);
	edb_book_print_delimiter(ep, status, " : ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.theme", NULL, ", ", "", NULL, EP_WARNING);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.name", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.awarder", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.date", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ".");

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}

static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	EDB_TABLE_Prize_XN,
/* language */	NULL,
/* std */	edb_book_print_prize,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_prize
};
DECLARE_PRINT_MODULE(prize, module_info)


