/*
	$Id: mod_thesis.c,v 1.7 2012/04/03 03:51:40 alex Exp alex $
	mod_thesis.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_thesis.c,v 1.7 2012/04/03 03:51:40 alex Exp alex $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

static	eid_t	language_japanese_list[] = LANGUAGE_JAPANESE_LIST ;

static
int
thesis_language(EdbPrint ep, EdbTupleInfo tuple)
{
	EdbTupleColumn	tc;
	EdbDatum	d;

	tc = edb_tuple_seek_column(ep->ec, tuple, (utf8_t *)"@.language");
	ForTCDatum(d, tc) {
		int	i;

		if(!DatumEIDisValid(d)) continue;
		for(i=0; i<Ns(language_japanese_list); ++i) {
			if(!EIDisVALID(language_japanese_list[i])) continue;
			if(DatumEID(d)==language_japanese_list[i]) return EP_LANG_Japanese;
		}
		return EP_LANG_English;
	}
	if(!edb_book_item_japanese(ep, tuple, "@.title")) return EP_LANG_English;
	return EP_LANG_Japanese;
}

#if 0
static
int
edb_book_print_thesis(EdbPrint ep, EdbTupleInfo tuple)
{
	int	japanese = TRUE;
	int	status = EP_STATUS_NORMAL;

	edb_print_push(ep);
	if(EpLang(ep)==EP_LANG_Auto) EpLang(ep) = EP_LANG_Japanese;
	edb_print_tuple_prefix(ep, tuple);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "[", "", "@.degree", NULL, ", ", "]", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, " : ");

	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.name", NULL, ", ", "", "○○ ○○", EP_ALERT);
	edb_print_pop(ep);
	edb_book_print_delimiter(ep, status, " : ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.title", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.date", NULL, ", ", ", ", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, "");

	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.teacher", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, "");

	status = edb_print_tuple_named_column(ep, tuple, NULL, " (", "", "@.teacher2", NULL, ", ", ")", "", EP_WARNING);
	edb_book_print_delimiter(ep, status, ", ");

	edb_print_tuple_named_column(ep, tuple, NULL, " [", "", "@.referee", NULL, ", ", "]", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, TRUE, ".");
	edb_print_pop(ep);

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}
#else
static
int
edb_book_print_thesis(EdbPrint ep, EdbTupleInfo tuple)
{
	int	language;
	int	status = EP_STATUS_NORMAL;

	edb_print_push(ep);
	language = EpLang(ep);
	if(EpLang(ep)==EP_LANG_Auto) language = thesis_language(ep, tuple);

	EpLang(ep) = EP_LANG_Japanese;
	edb_print_tuple_prefix(ep, tuple);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "[", "", "@.degree", NULL, ", ", "]", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, " : ");

	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.name", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, " : ");
	edb_print_pop(ep);

	edb_print_push(ep);
	EpLang(ep) = language;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.title", NULL, ", ", "", NULL, EP_ALERT);
	edb_print_pop(ep);
	edb_book_print_delimiter(ep, status, ", ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.date", NULL, ", ", ", ", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, "");

	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.teacher", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, "");

	status = edb_print_tuple_named_column(ep, tuple, NULL, " (", "", "@.teacher2", NULL, ", ", ")", "", EP_WARNING);
	edb_book_print_delimiter(ep, status, ", ");

	edb_print_tuple_named_column(ep, tuple, NULL, " [", "", "@.referee", NULL, ", ", "]", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, TRUE, ".");
	edb_print_pop(ep);

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}
#endif

static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	EDB_TABLE_Thesis_XN,
/* language */	thesis_language,
/* std */	edb_book_print_thesis,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_thesis
};
DECLARE_PRINT_MODULE(thesis, module_info)


