/*
	$Id: print_xml.c,v 1.6 2008/08/09 09:22:20 alex Exp $
	print_xml.c--- print TCD
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: print_xml.c,v 1.6 2008/08/09 09:22:20 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/tex.h"
#include	"edb/publish.h"

static
char *
edb_print_tuple_XML_datum(EdbContext ec, Doc doc, EdbTupleInfo tuple, Link l_column, int completion)
{
	EdbTableInfo	ti = TupleTable(tuple);
	Link	l, l_xml;
	char	*xml = NULL;

	l_xml = NULL;
	ForLink(l, l_column) {
		EdbTupleColumn	tc = (EdbTupleColumn)l->d;
		EdbColumnInfo		ci = tc->ci;
		register EdbDatum	datum;

		if(!completion && tc->mapped) continue;
		ForTCDatum(datum, tc) {
			EdbDatum d = edb_datum_dup(ec, DatumSuper(datum), datum);
			char	*datum_xml=NULL, *child_xml=NULL, *m_attr = NULL, *p_attr = NULL, *s;
			Caption	cap;
#if 0
#else
			char	*en, *ja, *pr;
#endif

			xml = NULL;
			if(datum->l_child) child_xml = edb_print_tuple_XML_datum(ec, doc, tuple, datum->l_child, completion);
			if(completion && DatumEIDisValid(datum) && ci->typeInfo->multilingual && (cap = edb_make_caption(ec, DatumEID(datum), CAP_norecurse))) {
#if 0
				FREE(d->d_english);
				FREE(d->d_japanese);
				FREE(d->d_pronounce);
				d->d_english = strdup_null(cap->c_main_english);
				d->d_japanese = strdup_null(cap->c_main_japanese);
				d->d_pronounce = strdup_null(cap->c_main_pronounce);
#else
				edb_datum_set(ec, d, DatumEID(d), cap->c_main_english, cap->c_main_japanese, cap->c_main_pronounce);
#endif
				edb_caption_free(ec, cap);
			}
#if 0
			doc_text_puts(doc, DatumEnglish(d));
			FREE(d->d_english);
			d->d_english = doc_sgets(doc);
			doc_text_puts(doc, DatumJapanese(d));
			FREE(d->d_japanese);
			d->d_japanese = doc_sgets(doc);
			doc_text_puts(doc, DatumPronounce(d));
			FREE(d->d_pronounce);
			d->d_pronounce = doc_sgets(doc);
#else
			doc_text_puts(doc, (char *)DatumEnglish(d));
			en = doc_sgets(doc);
			doc_text_puts(doc, (char *)DatumJapanese(d));
			ja = doc_sgets(doc);
			doc_text_puts(doc, (char *)DatumPronounce(d));
			pr = doc_sgets(doc);
			edb_datum_set(ec, d, DatumEID(d), (utf8_t *)en, (utf8_t *)ja, (utf8_t *)pr);
#endif

			if(ci->typeInfo) datum_xml = (char *)edb_datum_make_xml(ec, ColumnCType(ci), d, (utf8_t **)&m_attr, (utf8_t **)&p_attr, completion);
			edb_datum_free(ec, d);

			if(child_xml==NULL && datum_xml==NULL) {
				if(m_attr) asprintf(&xml, "<%s:%s %s%s%s/>", EDB_XMLNS, ColumnXN(ci), m_attr, p_attr?" ":"", p_attr ? p_attr : "");
			} else {
				asprintf(&xml, "<%s:%s%s%s%s%s>%s%s</%s:%s>", EDB_XMLNS, ColumnXN(ci),
					m_attr?" ":"",
					m_attr ? m_attr : "",
					p_attr?" ":"",
					p_attr ? p_attr : "",
					datum_xml ? datum_xml : "",
					child_xml ? child_xml : "",
					EDB_XMLNS, ColumnXN(ci));
			}
			FREE(child_xml);
			FREE(datum_xml);
			FREE(m_attr);
			FREE(p_attr);
			if(xml) LinkAppend(l_xml, link_atom_new(xml, free));
		}
	}
	xml = str_concatenate0(l_xml);
	link_free(l_xml);
	if(STRisVALID(xml)) return xml;
	FREE(xml);
	return NULL;
}

int
edb_print_tuple_XML(EdbPrint ep, EdbTupleInfo tuple)
{
	EdbContext	ec = ep->ec;
	Doc			doc = ep->doc;
	register int	status = FALSE;

	if(DocIsXML(doc)) {
		char	*xml = (char *)edb_tuple_make_xml(ec, tuple, TRUE);

		if(STRisVALID(xml)) {
			doc_printf(doc, "%s", xml);
			status = TRUE;
		}
		FREE(xml);
	} else {
		register char	*base_xml, *body_xml;
		Doc	sdoc;

		doc_printf(doc, "<?xml version=\"%s\" encoding=\"utf-8\"?><!DOCTYPE %s:%s SYSTEM \"%s%s.dtd\"><%s:%s xmlns:%s=\"%s\">",
			XML_DEFAULT_VERSION,
			EDB_XMLNS, TABLE_XN(TupleTable(tuple)), EDB_DTD_URI, TABLE_XN(TupleTable(tuple)),
			EDB_XMLNS, TABLE_XN(TupleTable(tuple)), EDB_XMLNS, EDB_XMLNS_URI);

		base_xml = (char *)edb_base_make_xml(ec, TupleBase(tuple), FALSE);
		doc_printf(doc, "%s", base_xml);
		FREE(base_xml);

		sdoc = doc_sopen(doc->dml);
		body_xml = edb_print_tuple_XML_datum(ec, sdoc, tuple, tuple->l_column, TRUE);
		doc_close(sdoc);
		doc_printf(doc, "%s", body_xml);
		FREE(body_xml);

		doc_printf(doc, "</%s:%s>", EDB_XMLNS, TupleXN(tuple));
		status = TRUE;
	}
	return status;
}


